﻿function PZ_Options_Frame()

---- Création de la fenêtre -----------------------------------------------------------------------
PZ_Options_Frame = CreateFrame("Frame", "", UIparent)
PZ_Options_Frame:SetClampedToScreen(true)
PZ_Options_Frame:SetMovable(true)
PZ_Options_Frame:SetFrameStrata("BACKGROUND")
PZ_Options_Frame:SetWidth(700)
PZ_Options_Frame:SetHeight(505)
PZ_Options_Frame:EnableMouse(true)
PZ_Options_Frame:RegisterForDrag("LeftButton")

PLAYERZONE_VERSION = GetAddOnMetadata("PlayerZone", "Version");


PZ_Options_Frame:SetBackdrop( { 
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background.blp", 
  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border.blp", tile = true, tileSize = 16, edgeSize = 16, 
  insets = { left = 5, right = 5, top = 5, bottom = 5 }
})

PZ_Options_Frame:SetBackdropColor(0, 0, 0, 0.8)
PZ_Options_Frame:SetPoint("CENTER")

---- FontStrings ---------------------------------------------------------------------------------
---------
--Title FS

local titleFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontHighlightLarge")
titleFS:SetText(PLAYERZONE_OPTIONS_TITLE)
titleFS:SetPoint("TOPLEFT", 20, -20)

-------------
--SubTitle FS

local subTitleFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontDisableSmall")
subTitleFS:SetText(PLAYERZONE_OPTIONS_LEFTCLICK)
subTitleFS:SetPoint("TOPLEFT", 20, -35)

-------------
--Version FS

local versionFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontHighlight")
versionFS:SetText(PLAYERZONE_VERSION)
versionFS:SetPoint("TOPRIGHT", -20, -20)
versionFS:SetTextColor(0.5, 0.5, 1)

---------
--Show FS

local showFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontNormal")
showFS:SetText(PLAYERZONE_OPTIONS_SHOW)
showFS:SetPoint("TOPLEFT", 50, -97)

---------
--Lock FS

local lockFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontNormal")
lockFS:SetText(PLAYERZONE_OPTIONS_LOCK)
lockFS:SetPoint("TOPLEFT", 50, -127)

------------
--Tooltip FS

local TooltipFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontNormal")
TooltipFS:SetText(PLAYERZONE_OPTIONS_TOOLTIP)
TooltipFS:SetPoint("TOPLEFT", 50, -157)

-------------
--WorldMap FS

local worldMapFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontNormal")
worldMapFS:SetText(PLAYERZONE_OPTIONS_WORLDMAP)
worldMapFS:SetPoint("TOPLEFT", 50, -187)

-----------
--Plugin FS

local pluginFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontNormal")
pluginFS:SetText(PLAYERZONE_OPTIONS_PLUGIN)
pluginFS:SetPoint("TOPLEFT", 50, -217)

--------------------
--Level World Map FS

local levelWorldMapFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontNormal")
levelWorldMapFS:SetText(PLAYERZONE_OPTIONS_LMSHOW)
levelWorldMapFS:SetPoint("TOPLEFT", 50, -247)

----------
--Color FS

local colorFS = PZ_Options_Frame:CreateFontString("", "OVERLAY", "GameFontNormal")
colorFS:SetText(PLAYERZONE_COLOR_FRAME)
colorFS:SetTextColor(0.5, 0.5, 1)
colorFS:SetPoint("CENTER", 0, -155)

---- Boutons -------------------------------------------------------------------------------------
-----------
--Bouton Ok
local pzof_yesButton = CreateFrame("Button", "", PZ_Options_Frame, "OptionsButtonTemplate")
pzof_yesButton:SetText("Ok")
pzof_yesButton:SetPoint("BOTTOMRIGHT", -10, 10)
pzof_yesButton:SetScript("OnClick", function()
	PZ_Options_Frame:Hide()
	PlaySound("GAMEDIALOGCLOSE")
end)

-------------------
--Bouton Désactiver
local pzof_DButton = CreateFrame("Button", "", PZ_Options_Frame, "OptionsButtonTemplate")
pzof_DButton:SetText(PLAYERZONE_USAGE_DISABLE)
pzof_DButton:SetPoint("CENTER", 250, 150)
pzof_DButton:SetScript("OnClick", function()
	PZCFrame_Toggle()
end)
pzof_DButton:SetScript("OnEnter", function(self)
	PlayerZoneDisable_OnEnter(self)
end)
pzof_DButton:SetScript("OnLeave", function()
	GameTooltip:Hide()
end)

--------------
--Bouton About
local pzof_AButton = CreateFrame("Button", "", PZ_Options_Frame, "OptionsButtonTemplate")
pzof_AButton:SetText(PLAYERZONE_USAGE_ABOUTS)
pzof_AButton:SetPoint("CENTER", 250, 90)
pzof_AButton:SetScript("OnClick", function()
	PlayerZone_Abouts_Toggle()
	PZ_Options_Frame:Hide()
	
end)
pzof_AButton:SetScript("OnEnter", function(self)
	PlayerZoneAbouts_OnEnter(self)
end)
pzof_AButton:SetScript("OnLeave", function()
	GameTooltip:Hide()
end)

------------------
--Bouton Commandes
local pzof_CButton = CreateFrame("Button", "", PZ_Options_Frame, "OptionsButtonTemplate")
pzof_CButton:SetText(PLAYERZONE_USAGE_COMMANDS)
pzof_CButton:SetPoint("CENTER", 250, 30)
pzof_CButton:SetScript("OnClick", function()
	PlayerZone_Commands_Toggle()
	PZ_Options_Frame:Hide();
end)
pzof_CButton:SetScript("OnEnter", function(self)
	PlayerZoneCommands_OnEnter(self)
end)
pzof_CButton:SetScript("OnLeave", function()
	GameTooltip:Hide()
end)

---------------
--Bouton Défaut
local pzof_DeButton = CreateFrame("Button", "", PZ_Options_Frame, "OptionsButtonTemplate")
pzof_DeButton:SetText(PLAYERZONE_OPTIONS_DEFAULT)
pzof_DeButton:SetPoint("CENTER", 250, -30)
pzof_DeButton:SetScript("OnClick", function()
	PlayerZone_DefaultOptions()
	PlayerZone_Options_Init()
	PlaySound("GAMEDIALOGOPEN")
end)
pzof_DeButton:SetScript("OnEnter", function(self)
	PlayerZoneDefault_OnEnter(self)
end)
pzof_DeButton:SetScript("OnLeave", function()
	GameTooltip:Hide()
end)

---- CheckButton --------------------------------------------------------------------------------------
-------------------
-- CheckButton show
pzof_SCButton = CreateFrame("CheckButton", "showCB", PZ_Options_Frame, "OptionsCheckButtonTemplate")
pzof_SCButton:SetPoint("TOPLEFT", 20, -90)
pzof_SCButton:SetScript("OnClick", function()
	PlayerZone_Toggle()
	PlaySound("GAMESPELLACTIVATE")
end)

-------------------
-- CheckButton lock
local pzof_LCButton = CreateFrame("CheckButton", "lockCB", PZ_Options_Frame, "OptionsCheckButtonTemplate")
pzof_LCButton:SetPoint("TOPLEFT", 20, -120)
pzof_LCButton:SetScript("OnClick", function()
	PlayerZone_Options.lock = not PlayerZone_Options.lock
	PlaySound("GAMESPELLACTIVATE")
end)

----------------------
-- CheckButton Tooltip
local pzof_TCButton = CreateFrame("CheckButton", "tooltipCB", PZ_Options_Frame, "OptionsCheckButtonTemplate")
pzof_TCButton:SetPoint("TOPLEFT", 20, -150)
pzof_TCButton:SetScript("OnClick", function()
	PlayerZone_Options.tooltip = not PlayerZone_Options.tooltip
	PlaySound("GAMESPELLACTIVATE")
end)

-----------------------
-- CheckButton WorldMap
local pzof_WMCButton = CreateFrame("CheckButton", "worldmapCB", PZ_Options_Frame, "OptionsCheckButtonTemplate")
pzof_WMCButton:SetPoint("TOPLEFT", 20, -180)
pzof_WMCButton:SetScript("OnClick", function()
	PlayerZone_WorldMap_Toggle()
	PlaySound("GAMESPELLACTIVATE")
end)

---------------------
-- CheckButton Plugin
local pzof_PCButton = CreateFrame("CheckButton", "pluginCB", PZ_Options_Frame, "OptionsCheckButtonTemplate")
pzof_PCButton:SetPoint("TOPLEFT", 20, -210)
pzof_PCButton:SetScript("OnClick", function()
	PlayerZone_Plugin_Toggle()
	PlaySound("GAMESPELLACTIVATE")
end)

--------------------------------
-- CheckButton LevelWorldMapShow
local pzof_LWMButton = CreateFrame("CheckButton", "levelWMCB", PZ_Options_Frame, "OptionsCheckButtonTemplate")
pzof_LWMButton:SetPoint("TOPLEFT", 20, -240)
pzof_LWMButton:SetScript("OnClick", function()
			PlayerZone_Options.showLM = not PlayerZone_Options.showLM
			PlayerZone_MapLevel_Toggle()
			PlaySound("GAMESPELLACTIVATE")
end)
----------------
local function BackDropSetup()
	PlayerZone_Frame:SetBackdropColor(PlayerZone_Options.red, PlayerZone_Options.green, PlayerZone_Options.blue)
	LevelZone_Frame:SetBackdropColor(PlayerZone_Options.red, PlayerZone_Options.green, PlayerZone_Options.blue)
end

---- Sliders --------------------------------------------------------------------------------------
--------------
--Edit Sliders

function PZ_SetupSlider(self, text)
	getglobal(self:GetName().."Text"):SetText(text);
end

-----------------
--Position Slider
local positionSlider = CreateFrame("Slider", "positionSlider", PZ_Options_Frame, "OptionsSliderTemplate")
positionSlider:SetPoint("CENTER", 0, -100)
positionSlider:SetMinMaxValues(0, 360)
getglobal(positionSlider:GetName().."Text"):SetText("Position du plugin")
getglobal(positionSlider:GetName().."High"):SetText("Droite")
getglobal(positionSlider:GetName().."Low"):SetText("Gauche")
positionSlider:SetScript("OnValueChanged", function()
	PlayerZone_Options.position = this:GetValue();
	PlayerZonePlugin_Update()
end)
------------------

------------
--Red Slider
local redSlider = CreateFrame("Slider", "redSlider", PZ_Options_Frame, "OptionsSliderTemplate")
redSlider:SetPoint("CENTER", -180, -185)
redSlider:SetMinMaxValues(0, 1)
getglobal(redSlider:GetName().."Text"):SetText(PLAYERZONE_OPTIONS_RED)
redSlider:SetScript("OnValueChanged", function()
	PlayerZone_Options.red = this:GetValue()
	BackDropSetup()
end)

--------------
--Green Slider
local greenSlider = CreateFrame("Slider", "greenSlider", PZ_Options_Frame, "OptionsSliderTemplate")
greenSlider:SetPoint("CENTER", 0, -185)
greenSlider:SetMinMaxValues(0, 1)
getglobal(greenSlider:GetName().."Text"):SetText(PLAYERZONE_OPTIONS_GREEN)
greenSlider:SetScript("OnValueChanged", function()
	PlayerZone_Options.green = this:GetValue()
	BackDropSetup()
end)

-------------
--blue Slider
local blueSlider = CreateFrame("Slider", "blueSlider", PZ_Options_Frame, "OptionsSliderTemplate")
blueSlider:SetPoint("CENTER", 180, -185)
blueSlider:SetMinMaxValues(0, 1)
getglobal(blueSlider:GetName().."Text"):SetText(PLAYERZONE_OPTIONS_BLUE)
blueSlider:SetScript("OnValueChanged", function()
	PlayerZone_Options.blue = this:GetValue()
	BackDropSetup()
end)

---- Scripts --------------------------------------------------------------------------------------

--------
--OnLoad
PZ_Options_Frame:SetScript("OnLoad", PZ_Options_Frame.show)

---------
--OnEvent
PZ_Options_Frame:SetScript("OnEvent", function(self, event, ...)
	PZ_OnEvent(self, event, ...)
end)
-------------
--OnDragStart
PZ_Options_Frame:SetScript("OnDragStart", PZ_Options_Frame.StartMoving)

------------
--OnDragStop
PZ_Options_Frame:SetScript("OnDragStop", PZ_Options_Frame.StopMovingOrSizing)

--------
--OnHide
PZ_Options_Frame:SetScript("OnHide", PZ_Options_Frame.StopMovingOrSizing)

PZ_Options_Frame:Hide()

end
